//=========================================================
// H8SX/1655 Project
//=========================================================
// File Name : dmac.c
// Function  : Control DMAC
//---------------------------------------------------------
// Rev.01 2009.09.13 Takanaga Yamazaki
//---------------------------------------------------------
// Copyright (C) 2009, 2010 Takanaga Yamazaki
//=========================================================
// ---- License Information -------------------------------
// Anyone can FREELY use this code fully or partially
// under conditions shown below.
// 1. You may use this code only for individual purpose,
//    and educational purpose.
//    Do not use this code for business even if partially.
// 2. You should use this code under the GNU GPL.
// 3. You should remain this header text in your codes
//   including Copyright credit and License Information.
// 4. Your codes should inherit this license information.
//=========================================================
// ---- Patent Notice -------------------------------------
// I have not cared whether this system (hw + sw) causes 
// infringement on the patent, copyright, trademark,
// or trade secret rights of others. You have all 
// responsibilities for determining if your designs
// and products infringe on the intellectual property
// rights of others, when you use technical information
// included in this system for your business.
//=========================================================
// ---- Disclaimers ---------------------------------------
// The function and reliability of this system are not 
// guaranteed. They may cause any damages to loss of
// properties, data, money, profits, life, or business.
// By adopting this system even partially, you assume
// all responsibility for its use.
//=========================================================

#include "api.h"

//=============================
// Memory Copy by DMAC(Ch3)
//=============================
void DMAC_memcpy(void *dst, void *src, UI32 bytes)
{
    //--------------------------
    // Start DMAC System Clock
    //--------------------------
    MSTP.CRA.BIT._DMAC = 0;
    //-----------------
    // Configure DMAC
    //-----------------
    DMAC3.DSAR = (void*) src;
    DMAC3.DDAR = (void*) dst;
    DMAC3.DOFR = 0x00000000;
    DMAC3.DTCR = bytes;
    DMAC3.DBSR = 0x00000000;
    DMAC3.DMDR.LONG = DMAC3.DMDR.LONG & 0x00000000;
    DMAC3.DMDR.BIT.DTSZ = 0; // Byte
    DMAC3.DMDR.BIT.DTF = 1;  // Auto Request Burst
    DMAC3.DACR.BIT.SAT = 2;  // Increment Source Address
    DMAC3.DACR.BIT.DAT = 2;  // Increment Destination Address
    DMAC3.DMRSR = 0x00;
    //--------------
    // Start DMA
    //--------------
    DMAC3.DMDR.BIT.DTE = 1;
    //-----------------------
    // Wait for Transfer End
    //-----------------------
    while(DMAC3.DMDR.BIT.DTE == 1);
    DMAC3.DMDR.LONG = 0x00000000;
}

//======================================================
// End of Program
//======================================================
