/*""FILE COMMENT""************************************************************
 *	System Name	: R0K561653D000BR USB DeviceDriver Firmware
 *	File Name	: dorequest.c
 *	Version		: 1.00-070920
 *	Contents	: 
 *	Customer	: 
 *	Model		: 
 *	Order		: 
 *	CPU			: H8SX/1653F
 *	Compiler	: ch38
 *	OS			: None
 *	Programmer	: 
 *	Notes		: 
 *****************************************************************************
 * (C)2004(2006) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION,
 *	 ALL RIGHTS RESERVED.
 *****************************************************************************
 *	History		: xxxx.xx.xx : Ver.0.01 ; Release
 *""FILE COMMENT END""*******************************************************/




#ifndef SysMemMap
#include	"SysMemMap.h"
#endif	/*	SysMemMap	*/

#ifndef CatProType
#include	"CatProType.h"
#endif	/*	CatProType	*/



/*	Prototype	*/
void DecStandardCommands(void);
enum DecControlCmdDoneType DecComCommands(void);



/*	Contents	*/
/***************************************************************************
Function Name	:DecStandardCommands(void)
Working			:Decoding Standard Setup Commands
Return Value	:void
Modified		:{Author : E.Ondo	[2003.Sep.29]}
Modified		:{Author : A.Ikeya	[2002.Jun.28]}
Modified		:{Author : T.Takenaga[1999.Jan.22]}
Modified		:{Author : T.Ishikawa[1998.Mar.11]}
Created			:{Author : T.Ishikawa[1997.Dec.11]}
***************************************************************************/
void	DecStandardCommands(void) {

	switch((ep0PacketGVar.access1Type.bmRequest)) {						/*	Judge command type	*/
		case	0x80:														/*	Standerd command	*/
			if(ep0PacketGVar.access1Type.bRequest == 6) {					/*	Get Descriptor	*/
				if (ep0PacketGVar.access0Type.wValue == 0x0001) {				/*	Judge descripter type	*/
																			/*	Device descripter	*/
					dataBuffGPtr[0].readPtr = deviceDiscriptorGVar[0].d_data;
					dataBuffGPtr[0].endAriaPtr = (unsigned char*)((deviceDiscriptorGVar[0].d_data) + (deviceDiscriptorGVar[0].length));
																														/*	Planned transfer length	*/
					dataBuffGPtr[0].writePtr = dataBuffGPtr[0].readPtr + LE2ByteRead(&ep0PacketGVar.access1Type.wLength_B1);
																														/*	Requested transfer length	*/
					if (dataBuffGPtr[0].writePtr > dataBuffGPtr[0].endAriaPtr) {										/*	Req. data > Plan. data	*/
						dataBuffGPtr[0].writePtr = (unsigned char*) dataBuffGPtr[0].endAriaPtr;
					}
				}
				else if (ep0PacketGVar.access0Type.wValue == 0x0002){														/*	configuration descripter	*/
					dataBuffGPtr[0].readPtr = configurationDiscriptorGVar[0].d_data;
					dataBuffGPtr[0].endAriaPtr = (unsigned char*)((configurationDiscriptorGVar[0].d_data) + (configurationDiscriptorGVar[0].length));
																														/*	Planned transfer length	*/
					dataBuffGPtr[0].writePtr = dataBuffGPtr[0].readPtr + LE2ByteRead(&ep0PacketGVar.access1Type.wLength_B1);
																														/*	Requested transfer length	*/
					if (dataBuffGPtr[0].writePtr > dataBuffGPtr[0].endAriaPtr) {										/*	Req. data > Plan. data	*/
						dataBuffGPtr[0].writePtr = (unsigned char*) dataBuffGPtr[0].endAriaPtr;
					}
				}
				else if ((ep0PacketGVar.access0Type.wValue & 0x00FF) == 0x0003) {		/*	String descripter	*/
					dataBuffGPtr[0].readPtr = stringDiscriptorGVar[ep0PacketGVar.access1Type.wValue_B1].d_data;
					dataBuffGPtr[0].endAriaPtr = (unsigned char*)((stringDiscriptorGVar[ep0PacketGVar.access1Type.wValue_B1].d_data)
							 + (stringDiscriptorGVar[ep0PacketGVar.access1Type.wValue_B1].length));						/*	Planned transfer length	*/
					dataBuffGPtr[0].writePtr = dataBuffGPtr[0].readPtr + LE2ByteRead(&ep0PacketGVar.access1Type.wLength_B1);
																														/*	Requested transfer length	*/
					if (dataBuffGPtr[0].writePtr > dataBuffGPtr[0].endAriaPtr) {										/*	Req. data > Plan. data	*/
						dataBuffGPtr[0].writePtr = (unsigned char*) dataBuffGPtr[0].endAriaPtr;
					}
				}
				else {														/*	configuration descripter	*/
					EpInfo[0].PresentState = STALL;
				}
			}
			else {
				EpInfo[0].PresentState = STALL;
			}
			break;
#if SET_ENABLE_CPU == 7622
		/*	Don't open	*/
#else
		case 0x00:
				/*	Trans.Out , Standard,  Device	*/
			if (ep0PacketGVar.access1Type.bRequest == 7) {
			/*	Set Descriptor	*/
			/*	set write pointers	*/
				dataBuffGPtr[0].writePtr = &controlBeginGVar;
				dataBuffGPtr[0].readPtr = &controlBeginGVar;
				dataBuffGPtr[0].beginAriaPtr = &controlBeginGVar;	
				dataBuffGPtr[0].endAriaPtr = &controlEndGVar;
				if (dataBuffGPtr[0].readPtr > dataBuffGPtr[0].endAriaPtr){
					dataBuffGPtr[0].readPtr = (unsigned char*) dataBuffGPtr[0].endAriaPtr;
				}
				
				/*	set Descriptors data area	*/
				if (ep0PacketGVar.access0Type.wValue == 0x0001) {
				/*	Device Descriptor	*/
					transStageGPtr.beginPtr = deviceDiscriptorGVar[0].d_data;
					transStageGPtr.endPtr = (unsigned char*)((deviceDiscriptorGVar[0].d_data) + (deviceDiscriptorGVar[0].length));
				}
				else if(ep0PacketGVar.access0Type.wValue == 0x0002) {
				/*	Configuration Descriptor	*/
					transStageGPtr.beginPtr = configurationDiscriptorGVar[0].d_data;
					transStageGPtr.endPtr = (unsigned char*)((configurationDiscriptorGVar[0].d_data) + (configurationDiscriptorGVar[0].length));
				}
				else if((ep0PacketGVar.access0Type.wValue & 0x00FF) == 0x0003) {
				/*	String Descriptor	*/
					transStageGPtr.beginPtr = stringDiscriptorGVar[ep0PacketGVar.access1Type.wValue_B1].d_data;
					transStageGPtr.endPtr = (unsigned char*)(stringDiscriptorGVar[ep0PacketGVar.access1Type.wValue_B1].d_data + stringDiscriptorGVar[ep0PacketGVar.access1Type.wValue_B1].length);
				}
				else {
					EpInfo[0].PresentState = STALL;
				}
			}
			else {
				EpInfo[0].PresentState = STALL;
			}
			break;
#endif	/*	SET_ENABLE_CPU	*/

		/*	These case are class commands.	*/
		case	0x20:	/*	0010 0000	*/	
		case	0x21:	/*	0010 0001	*/	
		case	0x22:	/*	0010 0010	*/	
		case	0x23:	/*	0010 0011	*/	
		case	0xA0:	/*	1010 0000	*/	
		case	0xA1:	/*	1010 0001	*/	
		case	0xA2:	/*	1010 0010	*/	
		case	0xA3:	/*	1010 0011	*/	
//			if (UNKNOWN_CTRL_COMMAND == ClassCommands()){	/* Set here Decode Class commands function 	*/
			if (UNKNOWN_CTRL_COMMAND == DecComCommands()){	/* Set here Decode Class commands function 	*/

				EpInfo[0].PresentState = STALL;
			}
			break;

		/*	These case are vender commands.	*/
		case	0x40:	/*	0100 0000	*/	
		case	0x41:	/*	0100 0001	*/	
		case	0x42:	/*	0100 0010	*/	
		case	0x43:	/*	0100 0011	*/	
		case	0xC0:	/*	1100 0000	*/	
		case	0xC1:	/*	1100 0001	*/	
		case	0xC2:	/*	1100 0010	*/	
		case	0xC3:	/*	1100 0011	*/	
		/*	Type is Vendor. Recipient is Device.	*/
			if (UNKNOWN_CTRL_COMMAND == DecVenderCommands()){
				EpInfo[0].PresentState = STALL;
			}
			break;

		default:
		/*	 the other case	*/
			EpInfo[0].PresentState = STALL;
			break;
	}

	if (EpInfo[0].PresentState != STALL){
		/*	set firmware state by Data Stage direction	*/
		if ((ep0PacketGVar.access1Type.bmRequest & 0x80) == 0x80) {
		/*	data transfer direction is Function to Host	*/
			EpInfo[0].PresentState = TRANS_IN;
		}
		else {
		/*	data transfer direction is Host to Function	*/
			EpInfo[0].PresentState = TRANS_OUT;
		}
	}
}
