/*
//=========================================================
// H8SX/1655 Project
//=========================================================
// File Name : start.S
// Function  : Startup Routine
//---------------------------------------------------------
// Rev.01 2009.08.13 Takanaga Yamazaki
//---------------------------------------------------------
// Copyright (C) 2009, 2010 Takanaga Yamazaki
//=========================================================
// ---- License Information -------------------------------
// Anyone can FREELY use this code fully or partially
// under conditions shown below.
// 1. You may use this code only for individual purpose,
//    and educational purpose.
//    Do not use this code for business even if partially.
// 2. You should use this code under the GNU GPL.
// 3. You should remain this header text in your codes
//   including Copyright credit and License Information.
// 4. Your codes should inherit this license information.
//=========================================================
// ---- Patent Notice -------------------------------------
// I have not cared whether this system (hw + sw) causes 
// infringement on the patent, copyright, trademark,
// or trade secret rights of others. You have all 
// responsibilities for determining if your designs
// and products infringe on the intellectual property
// rights of others, when you use technical information
// included in this system for your business.
//=========================================================
// ---- Disclaimers ---------------------------------------
// The function and reliability of this system are not 
// guaranteed. They may cause any damages to loss of
// properties, data, money, profits, life, or business.
// By adopting this system even partially, you assume
// all responsibility for its use.
//=========================================================
*/

/****************************************************************
;KPIT Cummins Infosystems Ltd, Pune, India. - 19-Apr-2005 
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE
;
;*****************************************************************/

/*********************************************************************
; File: start.asm
;
;
; desc:
; 
;  System initialisation routine - entry point for the application.
;  The stack pointer is initialised, then the hardware initialisation
;  routine called.  The static data areas are then initialised, before
;  the main function is executed.  A simple exit funtion is also
;  supplied
;
;*********************************************************************/

    .h8300sx

    .global _EXC_RESET
    .global _exit

#ifdef CPPAPP    
___dso_handle:
    .global ___dso_handle
#endif

    .extern _main
    .extern _GDB_STUB_main

    .extern _data
    .extern _mdata
    .extern _edata
    .extern _bss
    .extern _ebss
    .extern _stack_user_top
    .extern _stack_user_end
    .extern _stack_user_size


_EXC_RESET:
    ; initialize the SP for non-vectored code
    mov.l   #_stack_user_end, er7
    ; get the boundaries for the .data section initialisation
    mov.l   #_data,er0
    mov.l   #_edata,er1
    mov.l   #_mdata,er2
    cmp.l   er0,er1
    beq     start_1
start_l:
    mov.b   @er2,r3l  ;get from src
    mov.b   r3l,@er0  ;place in dest
    inc.l   #1,er2    ;inc src
    inc.l   #1,er0    ;inc dest
    cmp.l   er0,er1   ;dest == edata?
    bne     start_l
start_1:
    ; zero out bss
    mov.l   #_bss,er0
    mov.l   #_ebss,er1
    cmp.l   er0,er1         
    beq     start_3
    sub.b   r2l,r2l
start_2:
    mov.b   r2l,@er0
    inc.l   #1,er0
    cmp.l   er0,er1
    bne     start_2
start_3:
#ifdef CPPAPP    
    ;Initialize global constructor    
    jsr        @___main
#endif
    
    ; call the mainline     
    jsr     @_GDB_STUB_main
   ;jsr     @_main

    ; jump to exit
    mov.l   er0,er4
    jmp     @_exit

_exit:  nop
    bra _exit

/*
//======================================================
// End of Program
//======================================================
*/
