//=========================================================
// H8SX/1655 Project
//=========================================================
// File Name : cpg.c
// Function  : Initialize Clock Pulse Generator
//---------------------------------------------------------
// Rev.01 2009.08.13 Takanaga Yamazaki
//---------------------------------------------------------
// Copyright (C) 2009, 2010 Takanaga Yamazaki
//=========================================================
// ---- License Information -------------------------------
// Anyone can FREELY use this code fully or partially
// under conditions shown below.
// 1. You may use this code only for individual purpose,
//    and educational purpose.
//    Do not use this code for business even if partially.
// 2. You should use this code under the GNU GPL.
// 3. You should remain this header text in your codes
//   including Copyright credit and License Information.
// 4. Your codes should inherit this license information.
//=========================================================
// ---- Patent Notice -------------------------------------
// I have not cared whether this system (hw + sw) causes 
// infringement on the patent, copyright, trademark,
// or trade secret rights of others. You have all 
// responsibilities for determining if your designs
// and products infringe on the intellectual property
// rights of others, when you use technical information
// included in this system for your business.
//=========================================================
// ---- Disclaimers ---------------------------------------
// The function and reliability of this system are not 
// guaranteed. They may cause any damages to loss of
// properties, data, money, profits, life, or business.
// By adopting this system even partially, you assume
// all responsibility for its use.
//=========================================================

#include "api.h"

//================================
// Initialize CPG
//================================
void Init_CPG(void)
{
    //-----------------------------------------
    // Set All Internal Clocks in Maximum Speed
    //-----------------------------------------
    // ICLK = EXTAL x 4 (48MHz)
    // PCLK = EXTAL x 2 (24MHz)
    // BCLK = EXTAL x 1 (12MHz)
    SCKCR.WORD = (0 << 8) + (1 << 4) + (2 << 0);
    
#if 0
    //-------------------------------------------
    // Clear Module Stop for All Internal Modules
    //-------------------------------------------
    MSTP.CRA.BIT.ACSE    = 0;
    MSTP.CRA.BIT._EXDMAC = 0;
    MSTP.CRA.BIT._DMAC   = 0;
    MSTP.CRA.BIT._DTC    = 0;
    MSTP.CRA.BIT._TMR23  = 0;
    MSTP.CRA.BIT._TMR01  = 0;
    MSTP.CRA.BIT._DA     = 0;
    MSTP.CRA.BIT._AD0    = 0;
    MSTP.CRA.BIT._TPUU   = 0;
    MSTP.CRA.BIT._TPUL   = 0;
    //
    MSTP.CRB.BIT._PPG0   = 0;
    MSTP.CRB.BIT._SCI4   = 0;
    MSTP.CRB.BIT._SCI2   = 0;
    MSTP.CRB.BIT._SCI1   = 0;
    MSTP.CRB.BIT._SCI0   = 0;
    MSTP.CRB.BIT._IIC1   = 0;
    MSTP.CRB.BIT._IIC0   = 0;
    MSTP.CRB.BIT._UBC    = 0;
    //
    MSTP._CRC.BIT._SCI5  = 0;
    MSTP._CRC.BIT._SCI6  = 0;
    MSTP._CRC.BIT._TMR45 = 0;
    MSTP._CRC.BIT._TMR67 = 0;
    MSTP._CRC.BIT._USB   = 0;
    MSTP._CRC.BIT._CRC   = 0;
    MSTP._CRC.BIT._AD1   = 0;
    MSTP._CRC.BIT._PPG1  = 0;
    MSTP._CRC.BIT._RAM_4 = 0;
    MSTP._CRC.BIT._RAM32 = 0;
    MSTP._CRC.BIT._RAM10 = 0;
#endif
}

//======================================================
// End of Program
//======================================================
