//=========================================================
// H8SX/1655 Project
//=========================================================
// File Name : inlines.h
// Function  : In-line Assembler Routines
//---------------------------------------------------------
// Rev.01 2009.08.13 Takanaga Yamazaki
//---------------------------------------------------------
// Copyright (C) 2009, 2010 Takanaga Yamazaki
//=========================================================
// ---- License Information -------------------------------
// Anyone can FREELY use this code fully or partially
// under conditions shown below.
// 1. You may use this code only for individual purpose,
//    and educational purpose.
//    Do not use this code for business even if partially.
// 2. You should use this code under the GNU GPL.
// 3. You should remain this header text in your codes
//   including Copyright credit and License Information.
// 4. Your codes should inherit this license information.
//=========================================================
// ---- Patent Notice -------------------------------------
// I have not cared whether this system (hw + sw) causes 
// infringement on the patent, copyright, trademark,
// or trade secret rights of others. You have all 
// responsibilities for determining if your designs
// and products infringe on the intellectual property
// rights of others, when you use technical information
// included in this system for your business.
//=========================================================
// ---- Disclaimers ---------------------------------------
// The function and reliability of this system are not 
// guaranteed. They may cause any damages to loss of
// properties, data, money, profits, life, or business.
// By adopting this system even partially, you assume
// all responsibility for its use.
//=========================================================

/****************************************************************
KPIT Cummins Infosystems Ltd, Pune, India.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*****************************************************************/

#ifndef _INLINES_H
#define _INLINES_H

#define trapa(trap_no)	asm ("trapa  %0"::"g"(trap_no))
#define and_ccr(mask)   asm ("andc.b %0,ccr"::"g"(mask))

extern __inline__ void mcu_sleep (void) __attribute__ ((always_inline));
extern __inline__ void set_imask_ccr (unsigned char mask) __attribute__ ((always_inline));
extern __inline__ void set_imask_exr (unsigned char mask) __attribute__ ((always_inline));
extern __inline__ void set_ccr(unsigned char value) __attribute__ ((always_inline));
extern __inline__ unsigned char get_imask_exr (void) __attribute__ ((always_inline));
extern __inline__ unsigned char get_ccr(void) __attribute__ ((always_inline));

extern __inline__ void mcu_sleep (void)
{
  asm ("sleep");
}

extern __inline__ void set_imask_ccr (unsigned char mask)
{
  asm ("mov.l er0,@-er7");
  asm ("mov %0l, r0l"::"r"(mask));
  asm ("and.b #01,r0l");
  asm ("rotr.b r0l");
  asm ("stc.b ccr,r0h");
  asm ("and.b #127,r0h");
  asm ("or.b r0h,r0l");
  asm ("ldc r0l,ccr");
  asm ("mov.l @er7+,er0");
}

extern __inline__ void set_imask_exr (unsigned char mask)
{
  asm ("mov.l er0,@-er7");
  asm ("mov %0l, r0l"::"r"(mask)); //Get the value of mask in r01
  asm ("and.b #0x07,r0l");		// Mask it with 0x07 so that last 3 digits will be intact
  asm ("stc.b exr,r0h");		// Clear the int priority bits in exr reg
  asm ("and.b #248,r0h");
  asm ("or.b r0h,r0l"); 		// or them with the received one.
  asm ("ldc.b r0l,exr");
  asm ("mov.l @er7+,er0");
}

extern __inline__ unsigned char get_imask_exr(void)
{
    unsigned char imask;

    asm ("mov.l er0,@-er7");
    asm ("stc.b exr, r0l");
    asm ("and.b #0x07, r0l");
    asm ("mov r0l, %0l":"=r"(imask):);
    asm ("mov.l @er7+,er0");
    return imask;
}

extern __inline__ void set_ccr(unsigned char value)
{
       asm("mov.b %0l,r2l"::"r"(value));
       asm("ldc r2l, ccr");
}

extern __inline__ unsigned char get_ccr(void)
{
       unsigned char ccr_val;
       asm("stc ccr,r2l");
       asm("mov.b r2l, %0l"::"r"(ccr_val));
       return(ccr_val);
}

#endif /* _INLINES_H */

//======================================================
// End of Program
//======================================================
