/*""FILE COMMENT""************************************************************
 *	System Name	: R0K561653D000BR USB DeviceDriver Firmware
 *	File Name	: startup.c
 *	Version		: 1.00-070920
 *	Contents	: 
 *	Customer	: 
 *	Model		: 
 *	Order		: 
 *	CPU			: H8SX/1653F
 *	Compiler	: ch38
 *	OS			: None
 *	Programmer	: 
 *	Notes		: 
 *****************************************************************************
 * (C)2004(2006) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION,
 *	 ALL RIGHTS RESERVED.
 *****************************************************************************
 *	History		: xxxx.xx.xx : Ver.0.01 ; Release
 *""FILE COMMENT END""*******************************************************/




/*	Includes	*/
//#include	<machine.h>
#include "inlines.h"

#ifndef SysMemMap
#include	"SysMemMap.h"
#endif	/*	SysMemMap	*/

#include	"CatProType.h"


void			SetPowerOnSection(void);
void			SetOtherSection(void);
void			InitMemory(void);
void			USB_INITSCT(void);
void			InitSystem(void);
void			error(void);
void			ActBusVcc(unsigned long  ,unsigned char );
void			Set_EPInfoR(unsigned short);
void			UsbClose(void);

void			UsbSendData(void);
unsigned char	ChkUsbSendData(void);
unsigned char	ChkUsbReceiveData(void);
unsigned char	GetUsbReceiveData(void);


extern void		BranchOfInt(void);
extern	void	ActSerialIn(unsigned char);





/************************************************************************
Function Name	:SetPowerOnSection(void)
Working			:Initializing H8SX/1653
Return Value	:void
Modified		:{Author : E.Ondo[2005.Jun.10]}
Created			:{Author : A.Ikeya[2003.June.26]}
************************************************************************/
void	SetPowerOnSection(void) {

	//unsigned char	readLVar;
	//unsigned short	read16LVar;
	//unsigned long	read32LVar;
	//unsigned long	softWaitLVar;
	
//	unsigned short	LED_BUFF;

/*	Setting Register	*/			/*	bit Map	*/			/*	Note	*/

	MSTP._CRC.BIT._USB = 0;

	SetOtherSection();
	USB_INITSCT();												/*	initialized section B,D	*/

	InitMemory();											/*	Clear used RAM area	*/

//	LED_STRIPE												/*	Initialize completed	*/
	
	InitSystem();

	set_imask_exr(1);
//	set_imask_ccr(0);

}


void	UsbSendData(void)
{
	if (dataBuffGPtr[4].readPtr != dataBuffGPtr[4].writePtr) {	/*	Check BulkIn ringbuffer area	*/

		ActBulkIn();

	}
}

unsigned char	ChkUsbSendData(void)
{
	if( !BulkInFlag ){
		return(0);
	}else if( USB.DASTS.BIT.EP2DE ){
		return(0);
	}
	BulkInFlag = 0;
	return(1);
}

unsigned char	ChkUsbReceiveData(void)
{
	if (dataBuffGPtr[5].readPtr != dataBuffGPtr[5].writePtr) {	/*	Check BulkOut ringbuffer area	*/
		return(1);
	}else{
		return(0);
	}
}

unsigned char	GetUsbReceiveData(void)
{
	return(ActSerialOut(&dataBuffGPtr[5]));
}


/************************************************************************
Function Name	:SetOtherSection(void)
Working			:Setting other modules
Return Value	:void
Modified		:{Author : T.Sekine[2001.11.09]}
Modufied		:{Author : T.Ishikawa[1998.Mar.11]}
Created			:{Author : T.Ishikawa[1997.Nov.18]}
************************************************************************/
void	SetOtherSection(void) {


/*	Setting DMAC	*/
/*	Setting DTC	*/
/*	Setting WDT	*/
/*	Setting A/D	*/
/*	Setting D/A	*/

}


/***************************************************************************
Function Name	:_INITSCT(void)
Working			:Initializing section B,D
Return Value	:void
Created			:{Author : T.Sekine[2001.11.09]}
************************************************************************/

void	USB_INITSCT(void) {

	//unsigned char *p_s;
	//unsigned char *p_e;
	//unsigned char *p_r;

    /*
	p_s = __sectop("DUSB");
	p_e = __secend("DUSB");
	p_r = __sectop("RUSB");

	for(; p_s<p_e; p_s++, p_r++){
		*p_r = *p_s;
	}

	p_s = __sectop("DUSB$4");
	p_e = __secend("DUSB$4");
	p_r = __sectop("RUSB$4");

	for(; p_s<p_e; p_s++, p_r++){
		*p_r = *p_s;
	}

	p_s = __sectop("DUSB$1");
	p_e = __secend("DUSB$1");
	p_r = __sectop("RUSB$1");

	for(; p_s<p_e; p_s++, p_r++){
		*p_r = *p_s;
	}
	*/
}


/************************************************************************
Function Name	:InitMemory(void)
Working			:Clear Bulk Transfer Data Area
Return Value	:void
Modified		:{Author : E.Ondo[2005.Jun.10]}
Modified		:{Author : A.Ikeya[2003.June.26]}
Created			:{Author : T.Sekine[2001.11.09]}
************************************************************************/
void	InitMemory(void) {

	register unsigned long*	writePtrLVar;

//	LED_EDGE			/*	turn on LED for initializing	*/
	

	for (writePtrLVar = &bulkBeginLongGVar;writePtrLVar <= &bulkEndLongGVar;writePtrLVar++) {	/*	Bulk area is inialized to zeros	*/
		*writePtrLVar = 0;
	}
}



/************************************************************************
Function Name	:InitSystem(void)
Working			:Wakeup USB module
Return Value	:void
Modified		:{Author : E.Ondo[2005.Jun.10]}
Modified		:{Author : A.Ikeya[2003.June.26]}
Modified		:{Author : T.Sekine[2001.11.30]}
Modified		:{Author : T.Takenaga[1999.Jan.20]}
Created			:{Author : T.Ishikawa[1998.Jan.22]}
************************************************************************/
void	InitSystem(void) {

	/*	get interrupt enable flag	*/
	GET_INTERRUPT_ENABLE
	
//	set_imask_exr(1);
//	set_imask_ccr(0);
	
	SetUsbModule(0, 0);
	
	/*	Enable pullup D+	*/
	ENABLE_DPLUS_PULLUP

}



/***************************************************************************
Function Name	:error(void)
Working			:Occured ERROR
Return Value	:void
Modified		:{Author : E.Ondo[2005.Jun.10]}
Modified		:{Author : A.Ikeya[2003.June.26]}
Created			:{Author : T.Takenaga[2000.Jan.14]}
***************************************************************************/
void	error(void) {

//	LED_ERROR				/*	Display Error Code on LED	*/
	

	mcu_sleep();				/*	Go sleep	*/
}



/************************************************************************
Function Name	:ActBusVcc(unsigned long ,unsigned char )
Working			:Handling VBUS interrupt
Return Value	:void
Modified		:{Author : E.Ondo[2005.Jun.10]}
Modified		:{Author : A.Ikeya[2003.May.29]}
Modified		:{Author : T.Sekine[2001.Nov.09]}
Created			:{Author : T.Ishikawa[2000..]}
************************************************************************/
void	ActBusVcc(unsigned long interruptBitStreamLVar ,unsigned char EpInfoNumberLVar) {
	InterruptType	deviceSideLVar;					/*	For stored present value of interrupt flag resisters	*/
	
	int i=0;
	unsigned char vbus_state = 0;
	
	while(i < VBUS_CHK_LOOP){
		if (vbus_state == CABLE_STATE){
			i++;
		}
		else{
			i = 0;
			vbus_state = CABLE_STATE;
		}
	}
	
	F_CLEAR_BUSVCC									/*	Clear VBUSi flag	*/
	GET_INTERRUPT_REGISTER							/*	For renewal deviceSideLVar (Re-get the value of interrupt flag registers)	*/
	
	if(vbus_state){		//connected
													/*	A case of connecting USB cable 	*/
		CLEAR_ALL_FIFO								/*	Clear all FIFO	*/
		RUN_USB_MODULE_3							/*	Disable UDC core reset	*/
	}
	else {											/*	USB cable is disconnecteed	*/
		STOP_USB_MODULE_3							/*	Enable UDC core reset	*/
//		DISABLE_DPLUS_PULLUP						/*	Disable D+ Pullup	*/
	}
}

/***************************************************************************
Function Name	:Set_EPInfoR(unsigned short)
Working			:Write EndPointInfomation to (EPIR) Register
Return Value	:void
Modified		:{Author : A.Ikeya	[2004.Mar.08]}
Created			:{Author : A.Ikeya[2002.Jan.21]}
***************************************************************************/
void	Set_EPInfoR(unsigned short	How_Many) {

	int i;

	for (i=0; i < How_Many ; i++){
		EP_INFO_REGISTER = End_Point_Infomation[i];
	} 
}



void UsbClose(void)
{
	DISABLE_DPLUS_PULLUP
	MSTP._CRC.BIT._USB = 1;
}
