/*""FILE COMMENT""************************************************************
 *	System Name	: R0K561653D000BR USB DeviceDriver Firmware
 *	File Name	: dobulk.c
 *	Version		: 1.00-070920
 *	Contents	: 
 *	Customer	: 
 *	Model		: 
 *	Order		: 
 *	CPU			: H8SX/1653F
 *	Compiler	: ch38
 *	OS			: None
 *	Programmer	: 
 *	Notes		: 
 *****************************************************************************
 * (C)2004(2006) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION,
 *	 ALL RIGHTS RESERVED.
 *****************************************************************************
 *	History		: xxxx.xx.xx : Ver.0.01 ; Release
 *""FILE COMMENT END""*******************************************************/

#include "sys.h"


#ifndef SysMemMap
#include	"SysMemMap.h"
#endif	/*	SysMemMap	*/

#ifndef CatProType
#include	"CatProType.h"
#endif	/*	CatProType	*/


/*	Prototype	*/
void				ActBulkOut(unsigned long,unsigned char);
void				ActBulkIn(void);


unsigned char			BulkOutEnableFlag=1;


/*	Contents	*/
/***************************************************************************
Function Name	:ActBulkOut(unsigned long,unsigned char)
Working			:Controling Balk-Out Transfer
Return Value	:void
Modified		:{Author : A.Ikeya[2002.Jun.28]}
Modified		:{Author : T.Sekine[2001.Nov.09]}
Created			:{Author : T.Sekine[2001.Jul.10]}
***************************************************************************/
void	ActBulkOut(unsigned long interruptBitStreamLVar ,unsigned char EpInfoNumberLVar) {

	BULK_OTSF_CLEAR

	/*	Check write and read pointer in ringbuffer	*/
	if (dataBuffGPtr[BULKOUT_IDX].writePtr >= dataBuffGPtr[BULKOUT_IDX].readPtr) {
		if (((dataBuffGPtr[BULKOUT_IDX].endAriaPtr + 0x1 - dataBuffGPtr[BULKOUT_IDX].beginAriaPtr) -
			(dataBuffGPtr[BULKOUT_IDX].writePtr - dataBuffGPtr[BULKOUT_IDX].readPtr)) <= (EpInfo[BULKOUT_IDX].MaxPacketSize)) {

			SET_BULK_OUT_INT_DISABLE								/*	Disalble bulk-out interrupt for prevention overwirte of receive buffer	*/

		}
		else {
			GetPacket(&EpInfo[BULKOUT_IDX],&dataBuffGPtr[BULKOUT_IDX]);		/* Execute bulk-out transfer	*/
		}
	}
	else {
		if ((dataBuffGPtr[BULKOUT_IDX].readPtr - dataBuffGPtr[BULKOUT_IDX].writePtr) <= (EpInfo[BULKOUT_IDX].MaxPacketSize)) {

			SET_BULK_OUT_INT_DISABLE								/*	Disalble bulk-out interrupt for prevention overwirte of receive buffer	*/

		}
		else {
			GetPacket(&EpInfo[BULKOUT_IDX],&dataBuffGPtr[BULKOUT_IDX]);		/* Execute bulk-out transfer	*/
		}
	}
}



/*	Contents	*/
/***************************************************************************
Function Name	:ActBulkIn(void)
Working			:Controling Bulk-In Transfer
Return Value	:void
Modified		:{Author : T.Sekine[2001.Nov.21]}
Modified		:{Author : T.Sekine[2001.Nov.09]}
Created			:{Author : T.Sekine[2001.Jul.10]}
***************************************************************************/
void ActBulkIn(void)
{
	if ( ( BULK_IN_EMPTY_FLAG ) == BULK_IN_EMPTY_STATE ) {

		PutPacket(&EpInfo[BULKIN_IDX],&dataBuffGPtr[BULKIN_IDX]);									/*	Execute bulk-in transfer	*/

		BulkInFlag = 1;

/*	Check blank space of bulk-in ringbuffer , control data flow	*/

		if ( SerialInEnableFlag == 0x0 ) {													/*	A case of serial-in transfer disabled	*/

			if (dataBuffGPtr[BULKIN_IDX].writePtr >= dataBuffGPtr[BULKIN_IDX].readPtr) {
				if (((dataBuffGPtr[BULKIN_IDX].endAriaPtr + 0x1 - dataBuffGPtr[BULKIN_IDX].beginAriaPtr) -
					(dataBuffGPtr[BULKIN_IDX].writePtr - dataBuffGPtr[BULKIN_IDX].readPtr)) >= 0x60 ) {		/*	Check blank space	*/

					SET_SERIAL_IN_ENABLE													/*	Enable serial-in transfer	*/

				}
				else {
				}
			}
			else {
				if ((dataBuffGPtr[BULKIN_IDX].readPtr - dataBuffGPtr[BULKIN_IDX].writePtr) >= 0x60) {		/*	Check blank space	*/

					SET_SERIAL_IN_ENABLE													/*	Enable serial-in transfer	*/

				}
				else {
				}
			}
		}
		else {
		}
	}
}

