/*""FILE COMMENT""************************************************************
 *	System Name	: R0K561653D000BR USB DeviceDriver Firmware
 *	File Name	: dorequestcomcommand.c
 *	Version		: 1.00-070920
 *	Contents	: 
 *	Customer	: 
 *	Model		: 
 *	Order		: 
 *	CPU			: H8SX/1653F
 *	Compiler	: ch38
 *	OS			: None
 *	Programmer	: 
 *	Notes		: 
 *****************************************************************************
 * (C)2004(2006) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION,
 *	 ALL RIGHTS RESERVED.
 *****************************************************************************
 *	History		: xxxx.xx.xx : Ver.0.01 ; Release
 *""FILE COMMENT END""*******************************************************/




#ifndef SysMemMap
#include	"SysMemMap.h"
#endif	/*	SysMemMap	*/

#ifndef CatProType
#include	"CatProType.h"
#endif	/*	CatProType	*/

/*	Prototype	*/
enum	DecControlCmdDoneType				DecComCommands(void);
void    USBclear(void);


/*	Contents	*/
/***************************************************************************
Function Name	:DecComCommands(void)
Working			:Decoding Communication Class Commands
Return Value	:enum	DecControlCmdDoneType
Modified		:{Author : E.Ondo[2005.Jun.10]}
Modified		:{Author : E.Ondo[2003.Sep.29]}
Created			:{Author : S.Suzuki[2003.Jun.24]}
***************************************************************************/
enum DecControlCmdDoneType	DecComCommands(void) {

#if CLASS == USB_PRINTER_CLASS_DRIVER
	enum DecControlCmdDoneType	Command_Done = CTRL_COMMAND_DONE;

	switch(ep0PacketGVar.access1Type.bRequest){
		case 0x00:	/*	GET_DEVICE_ID	*/
			dataBuffGPtr[0].readPtr = PrinterDeviceIdGVar[0].d_data;
			dataBuffGPtr[0].endAriaPtr = (unsigned char*)((PrinterDeviceIdGVar[0].d_data) + (PrinterDeviceIdGVar[0].length));
																														/*	Planned transfer length	*/
			dataBuffGPtr[0].writePtr = dataBuffGPtr[0].readPtr + LE2ByteRead(&ep0PacketGVar.access1Type.wLength_B1);	/*	Requested transfer length	*/

			if (dataBuffGPtr[0].writePtr > dataBuffGPtr[0].endAriaPtr) {												/*	Req. data > Plan. data	*/
				dataBuffGPtr[0].writePtr = dataBuffGPtr[0].endAriaPtr;
			}
			break;
		case 0x01:	/*	GET_PORT_STATUS	*/
			dataBuffGPtr[0].readPtr = PrinterPortStausGVar[0].d_data;
			dataBuffGPtr[0].endAriaPtr = (unsigned char*)((PrinterPortStausGVar[0].d_data) + (PrinterPortStausGVar[0].length));
																														/*	Planned transfer length	*/
			dataBuffGPtr[0].writePtr = dataBuffGPtr[0].readPtr + LE2ByteRead(&ep0PacketGVar.access1Type.wLength_B1);	/*	Requested transfer length	*/

			if (dataBuffGPtr[0].writePtr > dataBuffGPtr[0].endAriaPtr) {												/*	Req. data > Plan. data	*/
				dataBuffGPtr[0].writePtr = dataBuffGPtr[0].endAriaPtr;
			}
			break;
		case 0x02:	/*	SOFT_RESET	*/
			dataBuffGPtr[0].writePtr = &controlBeginGVar;
			dataBuffGPtr[0].readPtr = &controlBeginGVar;
			dataBuffGPtr[0].beginAriaPtr = &controlBeginGVar;
			dataBuffGPtr[0].endAriaPtr = &controlEndGVar;

			Clear_All_Error
			break;
		default:
			/*	the other case	*/
			Command_Done = UNKNOWN_CTRL_COMMAND;
			break;
	}

#elif CLASS == USB_COMM_CLASS_DRIVER
	//int i;
	enum DecControlCmdDoneType	Command_Done = CTRL_COMMAND_DONE;

	switch(ep0PacketGVar.access1Type.bRequest){
		case 0x20:		/*	SET_LINE_CODING	*/
			dataBuffGPtr[0].writePtr = &controlBeginGVar;
			dataBuffGPtr[0].readPtr = &controlBeginGVar;
			dataBuffGPtr[0].beginAriaPtr = &controlBeginGVar;
			dataBuffGPtr[0].endAriaPtr = &controlEndGVar;
			transStageGPtr.beginPtr = LineCodingStructureGVar[0].d_data;
			transStageGPtr.endPtr = (unsigned char*)((LineCodingStructureGVar[0].d_data) + (LineCodingStructureGVar[0].length));
			break;

		case 0x21:		/*	GET_LINE_CODING	*/
			dataBuffGPtr[0].readPtr = LineCodingStructureGVar[0].d_data;
			dataBuffGPtr[0].endAriaPtr = (unsigned char*)((LineCodingStructureGVar[0].d_data) + (LineCodingStructureGVar[0].length));
																														/*	Planned transfer length	*/
			dataBuffGPtr[0].writePtr = dataBuffGPtr[0].readPtr + LE2ByteRead(&ep0PacketGVar.access1Type.wLength_B1);	/*	Requested transfer length	*/

			if (dataBuffGPtr[0].writePtr > dataBuffGPtr[0].endAriaPtr) {												/*	Req. data > Plan. data	*/
				dataBuffGPtr[0].writePtr = (unsigned char*) dataBuffGPtr[0].endAriaPtr;
			}
			break;

		case 0x22:		/*	SET_CONTROL_LINE_STATE	*/
			if (ep0PacketGVar.access1Type.wValue_B1 == 0x03) {
				USBclear();
			}
			break;

		case 0x23:		/*	SEND_BREAK	*/
			break;
		case 0x00:		/*	SEND_ENCAPSULATED_COMMAND */
			Command_Done = UNKNOWN_CTRL_COMMAND;
			break;
		case 0x01:		/*	GET_ENCAPSULATED_COMMAND */
			Command_Done = UNKNOWN_CTRL_COMMAND;
			break;
		default:
			/*	the other case	*/
			Command_Done = UNKNOWN_CTRL_COMMAND;
			break;
	}
	return Command_Done;

#else
	return UNKNOWN_CTRL_COMMAND;
#endif	/* end USB_PRINTER/COMM_CLASS_DRIVER */


}
