/*""FILE COMMENT""************************************************************
 *	System Name	: R0K561653D000BR USB DeviceDriver Firmware
 *	File Name	: setmacro.h
 *	Version		: 1.00-070920
 *	Contents	: 
 *	Customer	: 
 *	Model		: 
 *	Order		: 
 *	CPU			: H8SX/1653F
 *	Compiler	: ch38
 *	OS			: None
 *	Programmer	: 
 *	Notes		: 
 *****************************************************************************
 * (C)2004(2006) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION,
 *	 ALL RIGHTS RESERVED.
 *****************************************************************************
 *	History		: xxxx.xx.xx : Ver.0.01 ; Release
 *""FILE COMMENT END""*******************************************************/

#ifndef _SETMACRO_H_
#define _SETMACRO_H_

#define	JoinContents

// #define	POLL


/*	Register Definitions(H8SX/1653)	*/
#define	INTERRUPT0_REGISTER		USB.IFR0.BYTE
#define	INTERRUPT1_REGISTER		USB.IFR1.BYTE
#define	INTERRUPT2_REGISTER		USB.IFR2.BYTE

#define	STALL_REGISTER			USB.EPSTL.BYTE
#define	FIFO_CLEAR_REGISTER		USB.FCLR.BYTE
#define	READ_TRIGER_REGISTER	USB.TRG.BYTE
#define	WRITE_TRIGER_REGISTER	USB.TRG.BYTE

#define	EP_INFO_REGISTER		USB.EPIR

/*	each register bit	*/
/*	interrupt flag register	*/
#define	EP0_I_ACK_BITS					0x01000000		/*	EP0i_TS	*/
#define	EP0_I_NACK_BITS					0x02000000		/*	EP0i_TR	*/
#define	EP0_O_ACK_BITS					0x04000000		/*	EP0o_TS	*/
#define	SETUP_TS_BITS					0x08000000		/*	SETUP_TS	*/

#define	EP0_I_ACK_BIT					0x01			/*	EP0i_TS	*/
#define	EP0_I_NACK_BIT					0x02			/*	EP0i_TR	*/
#define	EP0_O_ACK_BIT					0x04			/*	EP0o_TS	*/
#define	SETUP_TS_BIT					0x08			/*	SETUP_TS	*/

#define	EP1_FULL_BIT					0x40			/*	EP1_FULL	*/
#define	EP2_EMPTY_BIT					0x10			/*	EP2_EMPTY	*/
#define	EP2_TR_BIT						0x20			/*	EP2_TR	*/
#define	BRST_BIT						0x80			/*	BRST	*/
#define	VBUS_F_BIT						0x01			/*	VBUS_F	*/
#define	VBUS_MN_BIT						0x08			/*	VBUS_MN	*/
/*	#define	EP3_ACK_BIT						0x0	EP3_TS	*/
/*	#define	EP3_NACK_BIT					0x10	EP3_TR	*/


/*	FIFO clear register	*/
#define	EP0I_FIFO_CLR_BIT				0x01	/*	EP0i	*/
#define	EP0O_FIFO_CLR_BIT				0x02	/*	EP0o	*/
#define	EP1_FIFO_CLR_BIT				0x20	/*	EP1	*/
#define	EP2_FIFO_CLR_BIT				0x10	/*	EP2	*/

#define	Xon							0x11
#define	Xoff						0x13


#define	BULKIN_IDX					4
#define	BULKOUT_IDX					5


/*	StartUp.c	*/
/*	pull up D+	*/
#define	ENABLE_DPLUS_PULLUP				USB.DMA.BYTE |= 0x04;	/*	---- -1--	*/	/*	PM4	*/

/*	disable pull up D+	*/
#define	DISABLE_DPLUS_PULLUP			USB.DMA.BYTE &= ~0x04;	/*	---- -0---	*/	/*	PM4	*/



/*	UsbMain.c	*/
#define	GET_INTERRUPT_REGISTER			deviceSideLVar.INTERRUPT.LONG = ((((unsigned long)INTERRUPT0_REGISTER) << 24) | (((unsigned long)INTERRUPT1_REGISTER) << 16) | (((unsigned long)INTERRUPT2_REGISTER) << 8));


#define	IRQ_CLEAR				/*	Not necessary Macro */


#define	READ_FINISH				READ_TRIGER_REGISTER = epInfoPtr->getFinish;


#define	WRITE_FINISH			WRITE_TRIGER_REGISTER = epInfoPtr->putEnable;


/*	Disable USB module-stop function	*/
#define	RUN_USB_MODULE_1				/*	not necessary	*/


/*	Disable Interface reset	*/
#define	RUN_USB_MODULE_2				/*	not necessary	*/


/*	Disable UDC core reset	*/
#define	RUN_USB_MODULE_3				/*	not necessary	*/


/*	Ebable UDC core reset	*/
#define	STOP_USB_MODULE_3				/*	not necessary	*/


/*	Clear PLLReady flag	*/
#define	F_CLEAR_PLLREADY				/*	not necessary	*/


/*	Set USB Information Register	*/
#define	SET_USB_EPINFO					Set_EPInfoR(50);	/*	5*10=50Byte	(H8SX1653)	*/


/*	Definitions of USB interrupt and DMA transfer	*/
#ifdef	POLL
#define	SET_USB_INTERRUPT				usb_ier_buf.IER0.BYTE = 0xCD;	/*	1100 1101	*/	/*	enable BRST,SETUPTS,EP0oTS,EP0iTR,EP0iTS	*/\
										usb_ier_buf.IER1.BYTE = 0x01;	/*	---- -001	*/	/*	enable VBUSi	*/\
										usb_ier_buf.IER2.BYTE = 0x00;	/*	---0 0-00	*/	/*	enable 	*/\
										USB.DMA.BYTE &= ~0x03;	/*	--00 --00	*/	/*	disable EP1,EP2 DMA	*/\
										USB.CTLR.BYTE |= 0x02;	/*	---- --1-	*/	/*	enable stall clear mode	*/
#else
#define	SET_USB_INTERRUPT				USB.IER0.BYTE = 0xCD;	/*	1100 1101	*/	/*	enable BRST,SETUPTS,EP0oTS,EP0iTR,EP0iTS	*/\
										USB.IER1.BYTE = 0x01;	/*	---- -001	*/	/*	enable VBUSi	*/\
										USB.IER2.BYTE = 0x00;	/*	---0 0-00	*/	/*	enable 	*/\
										USB.DMA.BYTE &= ~0x03;	/*	--00 --00	*/	/*	disable EP1,EP2 DMA	*/\
										USB.CTLR.BYTE |= 0x02;	/*	---- --1-	*/	/*	enable stall clear mode	*/
#endif


/*	Get informations of interrupt flags	*/

#ifdef POLL
#define	GET_INTERRUPT_ENABLE			interruptEnableBitsGVar.INTERRUPT.LONG = ((((unsigned long)usb_ier_buf.IER0.BYTE) << 24) | (((unsigned long)usb_ier_buf.IER1.BYTE) << 16) | (((unsigned long)usb_ier_buf.IER2.BYTE) << 8));\
										interruptEnableBitsGVar.INTERRUPT.LONG |= 0x00082000;
#else
#define	GET_INTERRUPT_ENABLE			interruptEnableBitsGVar.INTERRUPT.LONG = ((((unsigned long)USB.IER0.BYTE) << 24) | (((unsigned long)USB.IER1.BYTE) << 16) | (((unsigned long)USB.IER2.BYTE) << 8));\
										interruptEnableBitsGVar.INTERRUPT.LONG |= 0x00082000;
#endif


/*	Set USB_Interruput_Select_Register	*/
#ifdef	POLL
#define	SET_USB_INTERRUPT_SELECT		USB.ISR0.BYTE = 0x00;	/*	USBINT2	*/\
										USB.ISR1.BYTE = 0x00;\
										USB.ISR2.BYTE = 0x00;

#else
#if (USB_ISR_SELECT == 0)
#define	SET_USB_INTERRUPT_SELECT		USB.ISR0.BYTE = 0x00;	/*	USBINT2	*/\
										USB.ISR1.BYTE = 0x00;\
										USB.ISR2.BYTE = 0x04;

#elif (USB_ISR_SELECT == 1)
#define	SET_USB_INTERRUPT_SELECT		USB.ISR0.BYTE = 0xFF;	/*	USBINT3	*/\
										USB.ISR1.BYTE = 0x07;\
										USB.ISR2.BYTE = 0x1F;

#else

#endif
#endif

/*	Clear BRST_flag	*/
#define	F_CLEAR_BUSRESET			INTERRUPT0_REGISTER = (unsigned char) (~BRST_BIT);	/*	clear BRST flag	*/


/*	Clear all FIFOs	*/
#define	CLEAR_ALL_FIFO				FIFO_CLEAR_REGISTER = 0x73;	/*	0111 0011	*/	/*	clear EP0,1,2 FIFO	*/


/*	Clear VBUSi_flag	*/
#define	F_CLEAR_BUSVCC				INTERRUPT1_REGISTER = ~VBUS_F_BIT;	/*	clear VBUSi flag	*/


///*	Clear suspend/resume flag	*/
//#define	F_CLEAR_BUSCONDITION	INTERRUPT3_REGISTER = ~0x04;



/*	DoControl.c	*/
#define	CTRL_IN_OTSF_CLEAR				INTERRUPT0_REGISTER = ~(EP0_I_ACK_BIT | EP0_I_NACK_BIT | EP0_O_ACK_BIT);	/*	clear EP0 interrupt flag except for SETUP	*/

#define	SETUP_INTF_CLEAR				INTERRUPT0_REGISTER = ~(SETUP_TS_BIT);	/*	clear SETUP_TS interrupt flag	*/

#define	CTRL_ITSF_CLEAR					INTERRUPT0_REGISTER = ~(EP0_I_ACK_BIT);	/*	clear EP0i_TS flag	*/

#define	CTRL_OTSF_CLEAR					INTERRUPT0_REGISTER = ~(EP0_O_ACK_BIT);	/*	clear EP0o_TS flag	*/

#define	CTRL_ITRF_CLEAR					INTERRUPT0_REGISTER = ~(EP0_I_NACK_BIT);	/*	clear EP0i_TR flag	*/

#ifdef	POLL
#define	CTRL_IN_REG_SET					usb_ier_buf.IER0.BYTE &= ~(EP0_I_NACK_BIT);	/*	getting ready Control IN taransfer Data Stage after decodding Setup Command	*/

#define	CTRL_OUT_REG_SET				usb_ier_buf.IER0.BYTE |= (EP0_I_NACK_BIT);	/*	getting ready Control OUT taransfer Data Stage after decodding Setup Command	*/

#define	EP0_IER_ENABLE					usb_ier_buf.IER0.BYTE |= (EP0_I_ACK_BIT | EP0_I_NACK_BIT | EP0_O_ACK_BIT);

#define	EP0_IER_DISABLE					usb_ier_buf.IER0.BYTE &= ~(EP0_I_ACK_BIT | EP0_I_NACK_BIT | EP0_O_ACK_BIT);

#define	EP0I_TS_IER_DISABLE				usb_ier_buf.IER0.BYTE &= ~(EP0_I_ACK_BIT);

#else
#define	CTRL_IN_REG_SET					USB.IER0.BYTE &= ~(EP0_I_NACK_BIT);	/*	getting ready Control IN taransfer Data Stage after decodding Setup Command	*/

#define	CTRL_OUT_REG_SET				USB.IER0.BYTE |= (EP0_I_NACK_BIT);	/*	getting ready Control OUT taransfer Data Stage after decodding Setup Command	*/

#define	EP0_IER_ENABLE					USB.IER0.BYTE |= (EP0_I_ACK_BIT | EP0_I_NACK_BIT | EP0_O_ACK_BIT);

#define	EP0_IER_DISABLE					USB.IER0.BYTE &= ~(EP0_I_ACK_BIT | EP0_I_NACK_BIT | EP0_O_ACK_BIT);

#define	EP0I_TS_IER_DISABLE				USB.IER0.BYTE &= ~(EP0_I_ACK_BIT);

#define CONTROL_DATA_AREA				64

#endif


/*	DoBulk.c	*/

#define	BULK_OTSF_CLEAR					/*	not necessary	*/

#define	BULK_ITSF_CLEAR					/*	not necessary	*/

#define	BULK_ITFF_CLEAR					INTERRUPT0_REGISTER = ~EP2_TR_BIT;

									/*	Clear EP1TR	*/
#define	SET_BULK_IN_INTERRUPT2		/*	not necessary	*/

#define	SET_BULK_IN_INTERRUPT1		/*	not necessary	*/

//#define	STALL_REGISTER = EpInfo[EpInfoNumberLVar].stallEnable;
#define	EP_STALL					STALL_REGISTER = EpInfo[EpInfoNumberLVar].stallEnable;

#ifdef	POLL
#define	SET_BULK_OUT_INT_DISABLE	usb_ier_buf.IER0.BYTE &= (~0x40);\
									GET_INTERRUPT_ENABLE \
									BulkOutEnableFlag = 0;
#else
#define	SET_BULK_OUT_INT_DISABLE	USB.IER0.BYTE &= (~0x40);\
									GET_INTERRUPT_ENABLE \
									BulkOutEnableFlag = 0;
#endif

#define	SET_SERIAL_IN_ENABLE		SerialInEnableFlag = 0x1;

#define	BULK_IN_EMPTY_FLAG			INTERRUPT0_REGISTER & 0x10

#define	BULK_IN_EMPTY_STATE			0x10


/*	DoSerial.c	*/
#ifdef	POLL
#define	SET_BULK_OUT_INT_ENABLE		BulkOutEnableFlag = 1;\
									usb_ier_buf.IER0.BYTE |= (0x40);\
									GET_INTERRUPT_ENABLE
#else
#define	SET_BULK_OUT_INT_ENABLE		BulkOutEnableFlag = 1;\
									USB.IER0.BYTE |= (0x40);\
									GET_INTERRUPT_ENABLE
#endif


#define	SET_SERIAL_IN_DISABLE		SerialInEnableFlag = 0x0;

/*	DoRequestComCommand.c	*/
#define	Clear_All_Error


#define	VBUS_CHK_LOOP				20	/*	VBUS status Check loop	*/

#define	CABLE_STATE					((INTERRUPT1_REGISTER & 0x08) == 0x08)	/*	cable state	*/

#endif
