//=========================================================
// H8SX/1655 Project
//=========================================================
// File Name : console.c
// Function  : Serial Console Interface (USB or SCI4)
//---------------------------------------------------------
// Rev.01 2009.08.23 Takanaga Yamazaki
//---------------------------------------------------------
// Copyright (C) 2009, 2010 Takanaga Yamazaki
//=========================================================
// ---- License Information -------------------------------
// Anyone can FREELY use this code fully or partially
// under conditions shown below.
// 1. You may use this code only for individual purpose,
//    and educational purpose.
//    Do not use this code for business even if partially.
// 2. You should use this code under the GNU GPL.
// 3. You should remain this header text in your codes
//   including Copyright credit and License Information.
// 4. Your codes should inherit this license information.
//=========================================================
// ---- Patent Notice -------------------------------------
// I have not cared whether this system (hw + sw) causes 
// infringement on the patent, copyright, trademark,
// or trade secret rights of others. You have all 
// responsibilities for determining if your designs
// and products infringe on the intellectual property
// rights of others, when you use technical information
// included in this system for your business.
//=========================================================
// ---- Disclaimers ---------------------------------------
// The function and reliability of this system are not 
// guaranteed. They may cause any damages to loss of
// properties, data, money, profits, life, or business.
// By adopting this system even partially, you assume
// all responsibility for its use.
//=========================================================

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "sys.h"

//====================
// COM Port putchar()
//====================
UI08 COM_putchar(UI08 c)
{
#ifdef CONFIG_GDB_STUB_USB_ON
    if (c == '\n')
    {
        UART_Tx_Char('\r');
    }
    UART_Tx_Char(c);
#else
    if (c == '\n')
    {
        USB_Tx_Char('\r');
    }
    USB_Tx_Char(c);
#endif

    return c;
}

//====================
// COM Port getchar()
//====================
UI08 COM_getchar(void)
{
    UI08 ch;
#ifdef CONFIG_GDB_STUB_USB_ON
    ch = UART_Rx_Char();
#else
    ch = USB_Rx_Char();
#endif
    if (ch == '\r') ch = '\n';
    return ch;
}

//====================
// STUB putchar()
//====================
UI08 STUB_putchar(UI08 c)
{
#ifdef CONFIG_GDB_STUB_USB_ON
    if (c == '\n')
    {
        USB_Tx_Char('\r');
    }
    USB_Tx_Char(c);
#else
    if (c == '\n')
    {
        UART_Tx_Char('\r');
    }
    UART_Tx_Char(c);
#endif

    return c;
}

//====================
// STUB getchar()
//====================
UI08 STUB_getchar(void)
{
    UI08 ch;
#ifdef CONFIG_GDB_STUB_USB_ON
    ch = USB_Rx_Char();
#else
    ch = UART_Rx_Char();
#endif
    if (ch == '\r') ch = '\n';
    return ch;
}

//======================================================
// End of Program
//======================================================
