/*""FILE COMMENT""************************************************************
 *	System Name	: R0K561653D000BR USB DeviceDriver Firmware
 *	File Name	: sysmemmap.h
 *	Version		: 1.00-070920
 *	Contents	: 
 *	Customer	: 
 *	Model		: 
 *	Order		: 
 *	CPU			: H8SX/1653F
 *	Compiler	: ch38
 *	OS			: None
 *	Programmer	: 
 *	Notes		: 
 *****************************************************************************
 * (C)2004(2006) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION,
 *	 ALL RIGHTS RESERVED.
 *****************************************************************************
 *	History		: xxxx.xx.xx : Ver.0.01 ; Release
 *""FILE COMMENT END""*******************************************************/

#ifndef _SYSMEMMAP_H_
#define _SYSMEMMAP_H_

#define	SysMemMap

//#include	"..\iodefine.h"
#include    "iodefine.h"

#if 0
#define	AREA0_GDEF		0x00000000
#define	AREA1_GDEF		0x00200000
#define	AREA2_GDEF		0x00400000
#define	AREA3_GDEF		0x00600000
#define	AREA4_GDEF		0x00800000
#define	AREA5_GDEF		0x00A00000
#define	AREA6_GDEF		0x00C00000
#define	AREA7_GDEF		0x00E00000

#define	INRAM_BEGIN_GDEF	0x00FF3000
#define	INRAM_END_GDEF		(INRAM_BEGIN_GDEF+8+8) //0x00FFEFBC

//#define	INRAM2_BEGIN_GDEF	0x00FFFFC0
//#define	INRAM2_END_GDEF		0x00FFFFFF


#define	DATA_BUFF_BEGIN_GDEF	INRAM_END_GDEF
#define	DATA_BUFF_END_GDEF		(DATA_BUFF_BEGIN_GDEF + RINGBUFF_SIZE*2 -0x1) //0x00FFDFFF


#define	SRAM_START_GDEF		0x00600000
#define	SRAM_END_GDEF		0x007FFFFF



/* ---------------------- Data Area ------------------------------ */

#define	ep0PacketGVar			(*(volatile SetupDataType*)INRAM_BEGIN_GDEF)					/*	For control transfer(EP0)	*/
#define	controlBeginGVar		(*(volatile unsigned char*)(INRAM_BEGIN_GDEF + 8))
#define	controlEndGVar			(*(volatile unsigned char*)(INRAM_BEGIN_GDEF + 16 /*72*/))
#define	bulkBeginGVar			(*(volatile unsigned char*)DATA_BUFF_BEGIN_GDEF)
#define	bulkEndGVar				(*(volatile unsigned char*)DATA_BUFF_END_GDEF)
#define	bulkBeginLongGVar		(*(volatile unsigned long*)DATA_BUFF_BEGIN_GDEF)
#define	bulkEndLongGVar			(*(volatile unsigned long*)(DATA_BUFF_END_GDEF & 0xFFFFFFFC))
#define	interruptBeginGVar		(*(volatile unsigned char*)DATA_BUFF_BEGIN_GDEF)
#define	interruptEndGVar		(*(volatile unsigned char*)DATA_BUFF_END_GDEF)
#define	isochronousBeginGVar	(*(volatile unsigned char*)DATA_BUFF_BEGIN_GDEF)
#define	isochronousEndGVar		(*(volatile unsigned char*)DATA_BUFF_END_GDEF)


/*	Define BulkIn,Out Ringbuffer size	*/

#define	RINGBUFF_BASE_ADR	DATA_BUFF_BEGIN_GDEF		// Base Address of ringbuffer
//#define	RINGBUFF_BASE_ADR	SRAM_START_GDEF		// Base Address of ringbuffer

#define	RINGBUFF_SIZE	0x100		// Keep 256 Byte
//#define	RINGBUFF_SIZE	0x200		// Keep 512 Byte
//#define	RINGBUFF_SIZE	0x800		// Keep 2K Byte
//#define	RINGBUFF_SIZE	0x1400		// Keep 5K Byte
//#define	RINGBUFF_SIZE	0x100000	// Keep 1M Byte ( For SRAM )


#define	bulkoutBeginGVar			(*(volatile unsigned char*)RINGBUFF_BASE_ADR)
#define	bulkoutEndGVar				(*(volatile unsigned char*)(RINGBUFF_BASE_ADR + RINGBUFF_SIZE - 0x1))
#define	bulkinBeginGVar				(*(volatile unsigned char*)(RINGBUFF_BASE_ADR + RINGBUFF_SIZE))
#define	bulkinEndGVar				(*(volatile unsigned char*)(RINGBUFF_BASE_ADR + RINGBUFF_SIZE*2 -0x1))
#endif


#define	RINGBUFF_SIZE	0x100		// Keep 256 Byte


#define	ep0PacketGVar			usb_buf.ep0PacketGVar_buf					/*	For control transfer(EP0)	*/
#define	controlBeginGVar		usb_buf.controlBeginGVar_buf[0]
#define	controlEndGVar			usb_buf.controlBeginGVar_buf[8]
#define	bulkBeginGVar			(usb_buf.buf.buf1[0])
#define	bulkEndGVar				(usb_buf.buf.buf1[RINGBUFF_SIZE*2-1])
#define	bulkBeginLongGVar		(usb_buf.buf.buf4[0])
#define	bulkEndLongGVar			(usb_buf.buf.buf4[RINGBUFF_SIZE/2-1])

#define	bulkoutBeginGVar			usb_buf.buf.buf1[0]
#define	bulkoutEndGVar				usb_buf.buf.buf1[RINGBUFF_SIZE-1]
#define	bulkinBeginGVar				usb_buf.buf.buf1[RINGBUFF_SIZE]
#define	bulkinEndGVar				usb_buf.buf.buf1[RINGBUFF_SIZE*2-1]

#if 0
/***********************************************************
	LED Register DEFINITION
************************************************************/

//struct led_port{			/*******	LED Register DEFINITION	*********/
//	unsigned short	WORD;
//};
//#define LED						(*(volatile struct led_port*)	0x00200004)
//#define	LED_ALL_ON					LED.WORD = 0x0000;	
//#define	LED_ALL_OFF					LED.WORD = 0x00FF;	
//#define	LED_STRIPE					LED.WORD = 0x0055;	
//#define	LED_EDGE					LED.WORD = 0x007E;	
//#define	LED_ERROR					LED.WORD = 0x00CF;	
//#define	LED_HALF					LED.WORD = 0x00F0;	
//#define	LED_HALF2					LED.WORD = 0x000F;	
//#define LED_VALUE					LED.WORD
#endif

#endif
