/*""FILE COMMENT""************************************************************
 *	System Name	: R0K561653D000BR USB DeviceDriver Firmware
 *	File Name	: setusbinfo.h
 *	Version		: 1.00-070920
 *	Contents	: 
 *	Customer	: 
 *	Model		: 
 *	Order		: 
 *	CPU			: H8SX/1653F
 *	Compiler	: ch38
 *	OS			: None
 *	Programmer	: 
 *	Notes		: 
 *****************************************************************************
 * (C)2004(2006) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION,
 *	 ALL RIGHTS RESERVED.
 *****************************************************************************
 *	History		: xxxx.xx.xx : Ver.0.01 ; Release
 *""FILE COMMENT END""*******************************************************/

#ifndef _SETUSBINFO_H_
#define _SETUSBINFO_H_

#define	SetUsbInfo

//#pragma section USB

/*	For filtering interrupt flags (in BranchOfInt)	*/
InterruptType	interruptEnableBitsGVar = {{0xFFFFFFFF}};

EpInfoType	EpInfo[] = {
	/*	0	EP0s	*/
//	{0,	CONTROL,		&writeFifoSizeGVar[0],	&USB.EPDR0s.BYTE,	0x00,	0x04,	0x03,	0x01,	WAIT,	8},
	{0,	CONTROL,		&writeFifoSizeGVar[0],	&USB.EPDR0s,		0x00,	0x04,	0x03,	0x01,	WAIT,	8},
	/*	1	EP0In	*/
//	{0,	CONTROL,		&writeFifoSizeGVar[0],	&USB.EPDR0i.BYTE,	0x01,	0x02,	0x01,	0x01,	WAIT,	8},
	{0,	CONTROL,		&writeFifoSizeGVar[0],	&USB.EPDR0i,		0x01,	0x02,	0x01,	0x01,	WAIT,	8},
	/*	2	EP0Out	*/
//	{0,	CONTROL,		&USB.EPSZ0o,			&USB.EPDR0o.BYTE,	0x01,	0x02,	0x02,	0x01,	WAIT,	8},
	{0,	CONTROL,		&USB.EPSZ0o,			&USB.EPDR0o,		0x01,	0x02,	0x02,	0x01,	WAIT,	8},
	/*	3	EP3In	*/
//	{3,	INTERRUPT,		&writeFifoSizeGVar[0],	&USB.EPDR3.BYTE,	0x40,	0x00,	0x40,	0x08,	WAIT,	8},
	{3,	INTERRUPT,		&writeFifoSizeGVar[0],	&USB.EPDR3,			0x40,	0x00,	0x40,	0x08,	WAIT,	8},
	/*	4	EP2In	*/
//	{2,	BULK,			&writeFifoSizeGVar[3],	&USB.EPDR2.BYTE,	0x10,	0x00,	0x10,	0x04,	WAIT,	64},
	{2,	BULK,			&writeFifoSizeGVar[3],	&USB.EPDR2,			0x10,	0x00,	0x10,	0x04,	WAIT,	64},
	/*	5	EP1Out	*/
//	{1,	BULK,			&USB.EPSZ1,				&USB.EPDR1.BYTE,	0x00,	0x20,	0x20,	0x02,	WAIT,	64},
	{1,	BULK,			&USB.EPSZ1,				&USB.EPDR1,			0x00,	0x20,	0x20,	0x02,	WAIT,	64},
};

unsigned char	End_Point_Infomation[]={
/*	0000_00_00 00_00_0_000 0000000_0 00000000 00000000	*/

	0x00,0x00,0x10,0x00,0x00,	/* EP0 */
	0x14,0x20,0x80,0x00,0x01,	/* EP1 */
	0x24,0x28,0x80,0x00,0x02,	/* EP2 */
	0x34,0x38,0x10,0x00,0x03,	/* EP3 */
	0x00,0x00,0x00,0x00,0x00,	/* 000 */
	0x00,0x00,0x00,0x00,0x00,	/* 000 */
	0x00,0x00,0x00,0x00,0x00,	/* 000 */
	0x00,0x00,0x00,0x00,0x00,	/* 000 */
	0x00,0x00,0x00,0x00,0x00,	/* 000 */
	0x00,0x00,0x00,0x00,0x00	/* 000 */

};

/*	Define ringbuffer for reception of setup comand in control transfer	*/
BuffType	contCMDGPtr = {&ep0PacketGVar.byteVal[0],&ep0PacketGVar.byteVal[0],&ep0PacketGVar.byteVal[0],&ep0PacketGVar.byteVal[7]};


/*	Define ringbuffer for transition data	*/
BuffType	dataBuffGPtr[] = {
	{&controlBeginGVar,&controlBeginGVar,&controlBeginGVar,&controlEndGVar},						/*	For Control transfer	*/
	{0,0,0,0},																						/*	Not Use	*/
	{0,0,0,0},																						/*	Not Use	*/
	{0,0,0,0},																						/*	Not Use	*/
	{&bulkinBeginGVar,&bulkinBeginGVar,&bulkinBeginGVar,&bulkinEndGVar},							/*	For Bulk-in transfer	*/
	{&bulkoutBeginGVar,&bulkoutBeginGVar,&bulkoutBeginGVar,&bulkoutEndGVar},						/*	For Bulk-out transfer	*/
};


/*	Define relationship bewtween interrupu handling routines and EndPoint numbers	*/

LinkType	jump[] = {
	{0x80000000,0,(void*) ActBusReset},			/*	Bus Reset Interrupt	*/
	{0x05000000,1,(void*) ActControlInOut},		/*	EP0o Receive Complete (EP0o TS) / EP0i Transmit Complete (EP0i TS) Interrupt	*/
	{0x08000000,0,(void*) ActControl},			/*	SetUp Command Receive Complete (Setup TS) Interrupt	*/
	{0x02000000,1,(void*) ActControlInOut},		/*	EP0i Transfer Request (EP0i TR) Interrupt	*/
/*	{0x30000000,3,(void*) ActInterruptIn},*/	/*	EP3 Transfer Request (EP3 TR) / Tramsmit Complete (EP3 TS) Interrupt	*/
	{0x40000000,5,(void*) ActBulkOut},			/*	EP1 FIFO Full (EP1 Full) Interrupt	*/
	{0x10000000,4,(void*) ActBulkIn},			/*	EP2 FIFO Empty (EP2 Empty) Interrupt	*/
//	{0x00020000,4,(void*) ActBulkInReady},		/*	EP2 Transfer Request (EP2 TR) Interrupt	*/
	{0x00010000,0,(void*) ActBusVcc},			/*	USB Bus Connect (VBUS) Interrupt	*/
	{0x00000000,255,0}					/*	Terminal of table	*/
};



/*	For storing data in control-out transfer	*/
ControlType transStageGPtr = {0,0};


/*	Number of max bytes in one packet	*/
unsigned char	writeFifoSizeGVar[] = {8,16,49,64,128};



/*	Descriptor Informations	*/
unsigned char		DeviceItem[] = {
	0x12,
	0x01,
	0x10,
	0x01,
	0x02,	/* Communication Class */
	0x00,
	0x00,
	0x08,
	0x5B,	/* Vendor = Renesas Technology */
	0x04,	/*	""Attention"" Please use your company Vendor ID	*/
	0x20,	/* Product ID 0x0020 */
	0x00,
	0x00,
	0x01,
	0x00,
	0x00,
	0x03,	/* Strings Descriptor iSerialNumber */
	0x01
};

DeviceType		deviceDiscriptorGVar[] = {
	{18,DeviceItem}
};


/*	Configuration Descriptor informations , Data length = 67Byte	*/
unsigned char		configurationItem[] = {
	/* Configuration Descriptor */
	0x09,	/*	0:bLength */
	0x02,	/*	1:bDescriptorType */
	0x43,	/*	2:wTotalLength(L) */	/* 43'h (=67) */
	0x00,	/*	3:wTotalLength(H) */
	0x02,	/*  4:bNumInterfaces */
	0x01,	/*  5:bConfigurationValue */
	0x00,	/*  6:iConfiguration */
	0xC0,	/*	7:bmAttributes */	/* self powered */
	0x10,	/*	8:MAXPower */
		/* Interface Descriptor 1-0-0 [Communication Class] */
		0x09,	/*	0:bLength */
		0x04,	/*	1:bDescriptor */
		0x00,	/*	2:bInterfaceNumber */
		0x00,	/*	3:bAlternateSetting */
		0x01,	/*  4:bNumEndpoints */	/* support INT IN (= EP3) */
		0x02,	/*  5:bInterfaceClass */	/* Communication Interface Class */
		0x02,	/*  6:bInterfaceSubClass */	/* Abstruct Control Model */
		0x01,	/*  7:bInterfaceProtocol */	/* Common AT commands */
		0x00,	/*	8:iInterface */
		/* Class-Specific Configuration Descriptors */
		/* Header Functional Descriptor */
		0x05,	/*  0:length of this desc. */
		0x24,	/*  1:CS_INTERFACE */
		0x00,	/*  2:Header Functional Descr. */
		0x10,	/*  3:bcdCDC Rel. 1.10 */
		0x01,	/*  4:bcdCDC Rel. 1.10 */
		/* Abstract Control Management Functional Descriptor */
		0x04,	/*  0:length of this desc. */
		0x24,	/*  1:CS_INTERFACE */
		0x02,	/*  2:Abstr.Contr.Managm. F.D. */
		0x06,	/*  3:bmCapabilities */	/* support Send Break, Set Line Coding, Set Control Line State, Get Line Coding */
		/* Union Functional Descriptor */
		0x05,	/*  0:length of this desc. */
		0x24,	/*  1:CS_INTERFACE */
		0x06,	/*  2:Union Functional Descr. */
		0x00,	/*  3:bMasterInterface */
		0x01,	/*  4:bSlaveInterface0 */
		/* Call Management Functional Descriptor */
		0x05,	/*  0:length of this desc. */
		0x24,	/*  1:CS_INTERFACE */
		0x01,	/*  2:Call Managment F.D. */
		0x03,	/*  3:bmCapabilities */
		0x01,	/*  4:bDataInterface */
			/* Endpoint Descriptor 1-0-0-0 */
		 	0x07,	/*  0:bLength */
			0x05,	/*  1:bDescriptorType */
			0x83,	/*  2:bEndpointAddress */	/* IN, number = 3 */
			0x03, 	/*  3:bmAttribute */
			0x08, 	/*  4:wMAXPacketSize_lo */
		 	0x00, 	/*  5:wMAXPacketSize_hi */
			0x10,//0x10, 	/*  6:bInterval */
		/* Interface Descriptor 1-1-0 [Data Class Interface] */
		0x09, 	/*  0:bLength */
		0x04,	/*  1:bDescriptor */
		0x01, 	/*  2:bInterfaceNumber */
		0x00, 	/*  3:bAlternateSetting */
		0x02, 	/*  4:bNumEndpoints */	/* support Bulk OUT (= EP1) and Bulk IN (= EP2) */
		0x0A, 	/*  5:bInterfaceClass */ /* Data Interface Class */
		0x00, 	/*  6:bInterfaceSubClass */	/* unuse */
		0x00, 	/*  7:bInterfaceProtocol */ /* USB */
		0x00, 	/*  8:iInterface */
			/* Endpoint Descriptor 1-1-0-0 */
			0x07, 	/*  0:bLength */
			0x05,	/*  1:bDescriptorType */
			0x01,	/*  2:bEndpointAddress */
			0x02,	/*  3:bmAttribute */
			0x40, 	/*  4:wMAXPacketSize_lo */
			0x00, 	/*  5:wMAXPacketSize_hi */
			0x00,	/*  6:bInterval */
			/* Endpoint Descriptor 1-1-0-1 */
			0x07,	/*  0:bLength */
			0x05,	/*  1:bDescriptorType */
			0x82,	/*  2:bEndpointAddress */
			0x02,	/*  3:bmAttribute */
			0x40, 	/*  4:wMAXPacketSize_lo */
			0x00, 	/*  5:wMAXPacketSize_hi */
			0x00 	/*  6:bInterval */
};

ConfigurationType		configurationDiscriptorGVar[] = {
	{67,configurationItem}
};


/*	String Descriptor (sample)	*/
	const unsigned char		StringItem0[] = {0x04,0x03,0x09,0x04};	/*	STRING Descriptor (LANGID)	*/
						/*	0409	(Sample)(English)*/
	const unsigned char		StringItem1[] = {0x10,0x03,0x52,0x00,0x65,0x00,0x6E,0x00,
											0x65,0x00,0x73,0x00,0x61,0x00,0x73,0x00};	/*	Manufacturer STRING Descriptor(Sample)	*/
						/*	Renesas	(Sample)*/
	const unsigned char		StringItem2[] = {0x00};	/*	Product STRING Descriptor	*/
	const unsigned char		StringItem3[] = {0x1A,0x03,0x30,0x00,0x30,0x00,0x30,0x00,
											0x30,0x00,0x30,0x00,0x30,0x00,0x30,0x00,
											0x30,0x00,0x30,0x00,0x30,0x00,0x30,0x00,
											0x30,0x00,0x00,0x00};	/*	SerialNumber STRING Descriptor(Sample)	*/
						/*	000000000000	(Sample)*/
	const unsigned char		StringItem4[] = {0x00};	/*	Configration STRING Descriptor	*/
	const unsigned char		StringItem5[] = {0x00};	/*	Interface STRING Descriptor	*/
	
	StringType		stringDiscriptorGVar[] = {
		{ 4, (unsigned char*) StringItem0},
		{16, (unsigned char*) StringItem1},
		{ 0, (unsigned char*) StringItem2},
		{26, (unsigned char*) StringItem3},
		{ 0, (unsigned char*) StringItem4},
		{ 0, (unsigned char*) StringItem5}
	};


/*	Line Coding Structure	*/
unsigned char		LineCodingItem[] = {
	0x00,0x96,0x00,0x00,	/*	0-3	dwDTERate 	Bit Rate(bps)	Default : 0x1C200 (115200)	*/
	0x00,					/*	 4	bCharFormat Stop BIt		Default : 0 (1 Stop bit)	*/
	0x00,					/*	 5	bCharFormat Parity			Default : 0 (None )			*/
	0x08,					/*	 6	bCharFormat Data Bit		Default : 8					*/
	0x00					/*	 7	bCharFormat Flow Control	Default : 0 (SW or None)	*/
};

DeviceType		LineCodingStructureGVar[] = {
	{8,LineCodingItem}
};





UsbBuf	usb_buf;
usb_ier	usb_ier_buf;
unsigned char	BulkInFlag;

//#pragma section

#endif
